using SpellBoundAR.ResourceUtilities;
using UnityEngine;

namespace SpellBoundAR.ARImageTracking
{
    [CreateAssetMenu(menuName = "Scriptable Objects/AR/Image Tracking/Image Target Content")]
    public class ImageTargetContentData : ScriptableObject
    {
        [SerializeField] private ResourceGameObject prefabResource;

        public ImageTargetContent Content
        {
            get
            {
                if (!prefabResource) return null;
                GameObject prefab = prefabResource.Asset;
                if (!prefab) return null;
                ImageTargetContent content = prefab.GetComponent<ImageTargetContent>();
                if (content) return content;
                content = prefab.AddComponent<ImageTargetContent>();
                return content;
            }
        }
    }
}
