using SpellBoundAR.AssetManagement;
using SpellBoundAR.ResourceUtilities;
using UnityEngine;

namespace SpellBoundAR.ARImageTracking
{
    [CreateAssetMenu(menuName = "Scriptable Objects/AR/Image Tracking/Image Target")]
    public class ImageTargetData : IdentifiableScriptableObject
    {
        [Header("Settings")]
        [SerializeField] private bool contentEnabled = true;
        [SerializeField] private ImageTargetContentData contentData;
        [SerializeField] private Vector3 positionOffset;
        
        [Header("Image Target References")]
        [SerializeField] private Texture referenceImage;
        [SerializeField] private Sprite referenceSprite;

        public virtual bool ContentEnabled
        {
            get => contentEnabled;
            set => contentEnabled = value;
        }

        public ImageTargetContentData ContentData => contentData;
        public ImageTargetContent Content => contentData ? contentData.Content : null;
        public Texture ReferenceImage => referenceImage;
        public Sprite ReferenceSprite => referenceSprite;
        public Vector3 PositionOffset => positionOffset;

        public virtual void OnTracked() { }
    }
}
